% Some examples for the depth-first search interpreter.

module dfstest.

import dfs.

type    membb           A -> list A -> goal.
type    memb1           goal -> goal -> o.
type    memb2           goal -> goal -> o.
type    dfstest         A -> list A -> o.

memb1 (membb A (A::T)) tt.
memb2 (membb A (B::T)) (membb A T).

dfstest A Lis :-
   dfs_interp (memb1::memb2::nil) (membb A Lis).

kind    i               type.
type    aa              i.
type    bb              i.
type    cc              i.
type    dd              i.
type    ee              i.
type    test            i -> o.

test A :- dfstest A (aa::bb::cc::aa::dd::ee::aa::nil).
