module lf_fol.

import lfnorm.

type    i           ty.
type    form        ty.
type    lf_and      tm.
type    lf_imp      tm.
type    forall      tm.
type    ttrue       ty.
type    and_i       tm.
type    and_e1      tm.
type    and_e2      tm.
type    imp_i       tm.
type    imp_e       tm.
type    forall_i    tm.
type    forall_e    tm.

is_type i.
is_type form.

has_type (app_tm (app_tm lf_and A) B) form :- has_type A form, has_type B form.
has_type (app_tm (app_tm lf_imp A) B) form :- has_type A form, has_type B form.
has_type (app_tm forall A) form :-
  pi X\ (normal_tm1 X => has_type X i =>
         sigma N\ (norm_tm (app_tm A X) N, has_type N form)).

is_type (app_ty ttrue A) :- has_type A form.
