module lf_ni.

import lf_fol lfnorm.

has_type (app_tm (app_tm (app_tm (app_tm and_i A) B) P1) P2)
         (app_ty ttrue (app_tm (app_tm lf_and A) B)) :-
  has_type A form, has_type B form,
  has_type P1 (app_ty ttrue A), has_type P2 (app_ty ttrue B).

has_type (app_tm (app_tm (app_tm and_e1 A) B) P) (app_ty ttrue A) :-
  has_type A form, has_type B form,
  has_type P (app_ty ttrue (app_tm (app_tm lf_and A) B)).

has_type (app_tm (app_tm (app_tm and_e2 A) B) P) (app_ty ttrue B) :-
  has_type A form, has_type B form,
  has_type P (app_ty ttrue (app_tm (app_tm lf_and A) B)).

has_type (app_tm (app_tm (app_tm imp_i A) B) P)
         (app_ty ttrue (app_tm (app_tm lf_imp A) B)) :-
  has_type A form, has_type B form,
  pi Q\ (normal_tm1 Q => has_type Q (app_ty ttrue A) =>
         sigma N\ (norm_tm (app_tm P Q) N, has_type N (app_ty ttrue B))).

has_type (app_tm (app_tm (app_tm (app_tm imp_e A) B) P1) P2)
         (app_ty ttrue B) :-
  has_type A form, has_type B form,
  has_type P1 (app_ty ttrue A),
  has_type P2 (app_ty ttrue (app_tm (app_tm lf_imp A) B)).

has_type (app_tm (app_tm forall_i A) P) (app_ty ttrue (app_tm forall A)) :-
  pi X\ (normal_tm1 X => has_type X i =>
         sigma N\ (norm_tm (app_tm A X) N, has_type N form)),
  pi Y\ (normal_tm1 X => has_type Y i =>
         sigma N\ (sigma B\ (norm_tm (app_tm P Y) N,
                             norm_ty (app_ty ttrue (app_tm A Y)) B,
                             has_type N B))).

has_type (app_tm (app_tm (app_tm forall_e A) T) P) B :-
  norm_ty (app_ty ttrue (app_tm A T)) B,
  pi X\ (normal_tm1 X => has_type X i => 
         sigma N\ (norm_tm (app_tm A X) N, has_type N form)),
  has_type T i,
  has_type P (app_ty ttrue (app_tm forall A)).
