module niprfchk.

import niprover formulas nprfex.

type    proofcheck      name -> o.
type    test            int -> form -> nprf -> o.

proofcheck Name :- formula Name F, proofex Name P, has_proof P F.

test 1 F P :- formula distrib_quant1 F, proofex distrib_quant1 P,
              has_proof P F.
test 2 F P :- formula distrib_quant2 F, proofex distrib_quant2 P,
              has_proof P F.
test 3 F P :- formula distrib_quant3 F, proofex distrib_quant3 P,
              has_proof P F.
test 4 F P :- formula cases2 F, proofex cases2 P, has_proof P F.
